<ng-container *ngIf="{
          ghostElements: ghostElements$ | async,
          clubPage: dataPage$ | async } as vm">
  <app-page-form>
    <ng-container ngProjectAs="[page-form-content]">
      <h1>
        {{ 'admin.club.list.seo.title' | translate }}
      </h1>
      <p>
        {{ 'admin.club.list.seo.description' | translate }}
      </p>

      <section>
        <div class="table-wrapper">
          <table mat-table [dataSource]="loading.list ? vm.ghostElements : vm.clubPage?.items"
                 [trackBy]="trackBySlug"
                 matSort matSortDisableClear
                 (matSortChange)="sort($event)"
                 [matSortActive]="vm.clubPage?.sort?.field || 'name'"
                 [matSortDirection]="vm.clubPage?.sort?.direction || 'asc'">

            <ng-container matColumnDef="logo">
              <th mat-header-cell *matHeaderCellDef
                  class="logo">
                {{ 'admin.club.list.field.logo' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                <figure>
                  <img class="lazy-load"
                       *ngIf="'common.team.defaultPicture.url' | translate"
                       [lazyLoad]="element.logoUrl || ('common.team.defaultPicture.url' | translate)"
                       [errorImage]="'common.team.defaultPicture.url' | translate"
                       [alt]="element.name"/>
                </figure>
              </td>
            </ng-container>

            <ng-container matColumnDef="name">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.club.list.field.name' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.name }}
              </td>
            </ng-container>

            <ng-container matColumnDef="shortName">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.club.list.field.shortName' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.shortName }}
              </td>
            </ng-container>

            <ng-container matColumnDef="code">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.club.list.field.code' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.code | licenseNumber }}
              </td>
            </ng-container>

            <ng-container matColumnDef="city">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.club.list.field.city' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.city }}
              </td>
            </ng-container>

            <ng-container matColumnDef="action">
              <th mat-header-cell *matHeaderCellDef></th>
              <td mat-cell *matCellDef="let element"
                  class="actions">
                <a mat-icon-button
                   [routerLink]="[element.slug, 'update']"
                   [attr.aria-label]="'admin.common.action.update' | translate"
                   [matTooltip]="'admin.common.action.update' | translate"
                   matTooltipPosition="left">
                  <mat-icon>
                    edit
                  </mat-icon>
                </a>
                <a mat-icon-button
                   [routerLink]="[element.slug, 'duplicate']"
                   [attr.aria-label]="'admin.common.action.duplicate' | translate"
                   [matTooltip]="'admin.common.action.duplicate' | translate"
                   matTooltipPosition="left">
                  <mat-icon>
                    filter_none
                  </mat-icon>
                </a>
                <button mat-icon-button
                        (click)="delete(element)"
                        [attr.aria-label]="'admin.common.action.delete' | translate"
                        [matTooltip]="'admin.common.action.delete' | translate"
                        matTooltipPosition="left">
                  <mat-icon>
                    delete
                  </mat-icon>
                </button>
              </td>
            </ng-container>

            <ng-container *ngFor="let ghostColumn of ghostColumns">
              <ng-container [matColumnDef]="ghostColumn">
                <td mat-cell *matCellDef class="ghost"><div></div></td>
              </ng-container>
            </ng-container>

            <tr mat-header-row *matHeaderRowDef="columns; sticky: true"></tr>
            <ng-container *ngIf="loading.list then ghost; else data"></ng-container>
            <ng-template #data>
              <tr mat-row *matRowDef="let row; columns: columns;"></tr>
            </ng-template>
            <ng-template #ghost>
              <tr mat-row *matRowDef="let row; columns: ghostColumns;"></tr>
            </ng-template>
          </table>
        </div>
        <mat-paginator [length]="vm.clubPage?.count"
                       [pageIndex]="vm.clubPage?.page"
                       [pageSize]="vm.clubPage?.size"
                       [pageSizeOptions]="pageSizes"
                       (page)="goToPage($event)">
        </mat-paginator>
      </section>
    </ng-container>
    <ng-container ngProjectAs="[page-form-footer]">
      <a mat-flat-button color="primary"
         [routerLink]="['create']">
        <mat-icon>
          add
        </mat-icon>
        {{ 'admin.common.action.create' | translate }}
      </a>

      <app-async-button [loading]="loading.download">
        <button class="download" mat-stroked-button
                (click)="downloadCsv()">
          <mat-icon>
            attachment
          </mat-icon>
          {{ 'admin.common.action.download' | translate }}
        </button>
      </app-async-button>

      <button mat-stroked-button color="primary"
              (click)="fileUpload()">
        <mat-icon>
          cloud_upload
        </mat-icon>
        {{ 'admin.common.action.upload' | translate }}
      </button>
    </ng-container>
  </app-page-form>
</ng-container>
